#include <stdio.h>
#include <stdlib.h>

#define Infinit 32767

typedef struct     //structura unei camere
	 {
	   int nr,    //numarul de persoane
	   elev[9];   //cei (maxim) 9 elevi (indicii)
       int G;     //greutatea echipei
	 } echipa;

int    elev[10];
echipa  E[6], best_E[6];
int     N, P;
int    best_suma=Infinit;

int Abs(int x)
{
  if (x<0) return -x;
  return x;
}

int calc_suma(void) //calculeaza suma diferentelor
{
  int suma=0;
  int i,j;
  for (i=0; i<P; i++)
    for (j=i+1; j<P; j++)
      suma+=Abs(E[i].G-E[j].G);
  return(suma);
}

void citire(void)
{
  int i, j;
  FILE *inp;
  inp=fopen("concurs.in","r");
  fscanf(inp, "%d %d", &N, &P);
  for (i=0; i<6; i++)  //initializeaza cu 0 toate echipele
    {
      E[i].nr=0;           //numarul de elevi
      for (j=0; j<9; j++)
        E[i].elev[j]=0;    //elevul j
      E[i].G=0;            //greutatea echipei
    }
  for (i=0; i<N; i++) //greutatile elevilor
    fscanf(inp, "%d ", &(elev[i]));
 fclose(inp);
}

void afisare(void)
{
  int i, j;
  FILE  *g;
  g=fopen("concurs.out","w");
  fprintf(g,"%d\n",best_suma);
  for (i=0; i<P; i++)
    {
      for (j=0; j<best_E[i].nr; j++)
        fprintf(g, "%d ", best_E[i].elev[j]+1);
      fprintf(g, "\n");
    }
  fclose(g);
  exit(0);
}

int Echipa_goala(void)
{
  int i;
  for (i=0; i<P; i++)
    if (E[i].nr==0) return 1;
  return 0;
}

void calcul(int k)        //back - se incearca repartizarea
{                         //       elevului k
  int suma;
  int i,j;
  if (k==N)               //daca le-am repartizat pe toti
    {
    if (!Echipa_goala())  //daca nu exista echipa vida
      {
        suma=calc_suma();   //calculam suma diferentelor
        if (suma<best_suma) //daca e mai buna
          {
            best_suma=suma;   //o retinem
            for (i=0; i<6; i++)//si retinem configuratia
              best_E[i]=E[i];   //echipelor
            if (best_suma==0)
              {
                afisare();
              }
          }
      }
    }
  else                 //nu i-am repartizat pe toti
    for (j=0; j<P; j++)//parcurg toate echipele si
      if (E[j].nr<9)    //daca in echipa j mai e loc
	    {
	      E[j].elev[E[j].nr]=k;//pun elevul k aici
	      E[j].nr++;           //numar inca un elev
          E[j].G+=elev[k];     //actualizez greutatea echipei
	      calcul(k+1);         //trec la elevul urmator
	      E[j].nr--;           //revin scad numarul de elevi
	      E[j].elev[E[j].nr]=0;//sterg indicele
          E[j].G-=elev[k];
	    }
}

void main(void)
{
  citire();
  calcul(0);
  afisare();
}
