Program Tricou;
CONST MAX = 60;
Type CeVreaConcurent = Record
                   mi, mf: Integer;
                 End;
     Concurent = Integer;

Var Fin, Fout: Text;
    n, Cati, CatiMax, SDisp, PanaAiciCaut: Integer;
    Marime: Array[1..MAX] Of CeVreaConcurent;
    Disponibile: Array[1..5] Of Integer;
    Sol: Array[1..MAX] Of Boolean;
    SolNr: Array[1..MAX] Of Integer;

Function min(x, y: Integer): Integer;
Begin
  min := x;
  If y<x Then min := y
End;

Procedure Citire;
Var i, j, DeLa, PanaLa: Integer;
    x1, x2: Char;
Begin
  ReadLn(Fin, n);
  For i := 1 To n Do          {pentru cei n concurenti}
    Begin
      Read(Fin, x1, x2);      {citesc marime mica si marime mare}
      Case x1 Of              {transform in indice x1}
        'S': DeLa := 1;
        'M': DeLa := 2;
        'L': DeLa := 3;
        'X': DeLa := 4;
        'T': DeLa := 5;
      End;
      Case x2 Of              {transform in indice x2}
        'S': PanaLa := 1;
        'M': PanaLa := 2;
        'L': PanaLa := 3;
        'X': PanaLa := 4;
        'T': PanaLa := 5;
      End;
      Marime[i].mi := DeLa;   {retin pentru concurentul i}
      Marime[i].mf := PanaLa; {marimile solicitate       }
      Read(Fin, x1);    {citesc spatiul dintre concurenti/enterul de la sfarsit}
    End;
  For i := 1 To 5 Do          {numarul de tricouri disponibile}
    Begin
      Read(Fin, Disponibile[i]);
      Sdisp := Sdisp + Disponibile[i]
    End;
  PanaAiciCaut := min(n, SDisp);
  Close(Fin)
End;

Function V(i: Concurent): Integer;
Begin
  V := Marime[i].mi * 10 + Marime[i].mf
End;

Procedure Ordoneaza;                {sortez crescator dupa marimi cerute}
Var Aux: CeVreaConcurent;
    i, j: Concurent;
Begin
  For i := 1 To n-1 Do
    For j := i+1 To n Do
      If V(i)>V(j) Then
        Begin
          Aux := Marime[i];
          Marime[i] := Marime[j];
          Marime[j] := Aux
        End;
End;

Procedure Da_Tricou(m: Integer; k: Concurent);   {incerc sa dau tricou de marimea m concurentului k}
Var i, j: Integer;
    Dat: Boolean;
Begin
  If CatiMax=PanaAiciCaut Then exit;        {mai mult oricum nu se poate}
  If (m<=5) AND (k<=n) Then                 {daca mai am marimi de distribuit si mai am cui}
    If Disponibile[m]>0 Then
      Begin
            If (m>=Marime[k].mi) AND (m<=Marime[k].mf) AND NOT Sol[k] Then  {daca mai sunt}
              Begin  {daca concurentul k vrea marimea asta si mai am tricouri de marimea asta (m)}
                Sol[k] := TRUE; Inc(Cati);           {da tricou si numara ca mai ai un concurent cu tricou}
                SolNr[k] := m;
                Dat := TRUE;
                Dec(Disponibile[m]);                 {l-ai dat, scade din disponibile}
                If Cati>CatiMax Then CatiMax := Cati;{vezi daca sunt mai multi cu tricou decat pana acum}
                Da_Tricou(m, k+1);                   {aceasi marime, treci la alt concurent}
                Inc(Disponibile[m]);                      {la revenire refa disponibile}
                Dec(Cati);                                {ii iau tricoul}
                SolNr[k] := 0;
                Dat := FALSE;
                Sol[k] := FALSE                           {il scot din solutie}
              End
            Else
              If (m<Marime[k].mi) OR (m>Marime[k].mf) Then {nu vrea marimea asta}
                Begin                {incerc}
                   Da_Tricou(m+1, k);     {alta marime acelasi concurent}
                   Da_Tricou(m, k+1)      {aceasi marime alt comcurent}
                End
      End
    Else                                {daca nu mai sunt tricouri}
      Da_Tricou(m+1, k)                   {treci la alta marime de tricou}
End;

Procedure Da_Unice;
Var i, j: Concurent;
Begin
  i := 1;
  While i<=n Do
    Begin
      If Marime[i].mi=Marime[i].mf Then    {daca vrea NUMAI un anumit tricou, ca marime}
        If Disponibile[Marime[i].mi]>0 Then{si exista aceasta marime}
          Begin
            Dec(Disponibile[Marime[i].mi]);  {da-i un astfel de tricou}
            For j := i+1 To n Do
              Marime[j-1] := Marime[j];   {scoate-l din lista}
            Inc(CatiMax);                 {numara ca ai un concurent cu tricou}
            n := n-1;                     {am cu unul mai putin de dat tricouri}
            i := i-1                      {poate e si urmatorul}
          End;
      i := i+1                   {trec la urmatorul concurent}
    End;
End;

Begin
  Assign(Fin, 'tricouri.in'); Reset(Fin);
  Assign(Fout, 'tricouri.out'); ReWrite(Fout);
  Citire;        {citeste datele si retine informatiile utile}
  Ordoneaza;     {crescator dupa marimile solicitate}
  Da_Unice;      {apoi dau tricourile solicitate sigur !!! unde se poate, evident}
  Cati := CatiMax;  {atatea tricouri am dat pana acum}

  Da_Tricou(1, 1);  {incep sa dau tricouri incepand cu prima marime si primul concurent}

  WriteLn(Fout, CatiMax);  {atatia au primit tricouri}
  Close(Fout);
End.
