#include <stdio.h>

#define MAX 1000

int dx[4]={-1, 0, 1, 0};
int dy[4]={0, 1, 0, -1};
int t[32][32], a[32][32], n, m, i_prim, j_prim, l_s, l_j;

void citire(void)
{
  int i, j;
  FILE *f;
  f=fopen("albina.in","r");
  fscanf(f,"%d %d", &n, &m);
  fscanf(f,"%d %d", &i_prim, &j_prim);
  fscanf(f,"%d %d", &l_s, &l_j);
  for(i=1; i<=n; i++)
    for(j=1; j<=m; j++)
      fscanf(f, "%d", &a[i][j]);
  fclose(f);
}

void bordare(void)
{
  int i, j;
  for(i=0; i<=n+1; i++)
    a[i][0]=a[i][m+1]=MAX;
  for(j=0; j<=m+1; j++)
    a[0][j]=a[n+1][j]=MAX;
}

void depune(int i, int j)
{
  int i_nou, j_nou, l;
  t[i][j]=1;
  for(l=0;l<4;l++)
    {
	  i_nou=i+dx[l]; j_nou=j+dy[l];
	  if(t[i_nou][j_nou]==0)
	    {
	      if ((a[i][j]>=a[i_nou][j_nou])&&(a[i][j]-a[i_nou][j_nou]<=l_j))
	        depune(i_nou,j_nou);
	      if ((a[i][j]<a[i_nou][j_nou])&&(a[i_nou][j_nou]-a[i][j]<=l_s))
	        depune(i_nou,j_nou);
	    }
    }
}

int aria(void)
{
  int i, j, k, l, i1, j1;
  int Max=0,p;
  for(i=1; i<=n; i++)
    for(j=1; j<=m; j++)
      if(t[i][j])                     //pentru fiecare floare polenizata
	    for(k=i; k<=n; k++)           //colt stanga-sus
	      for(l=j; l<=m; l++)         //se cauta
		    if(t[k][l])               //o alta floare polenizata
		      {                       //colt dreapta-jos
		        p=1;                      //in dreptunghiul determinat
		        for(i1=i; i1<=k; i1++)    //de aceste doua flori se face
		          for(j1=j; j1<=l; j1++)  //produsul elementelor
		            p*=t[i1][j1];         //elementele din t sunt 0 sau 1
		        if(p)                    //daca toate au fost 1
		          if((k-i+1)*(l-j+1)>Max)//am determinat un dreptunghi plin
			        Max=(k-i+1)*(l-j+1); //retin maximul aflat pana acum
		      }
   return Max;
}

int main()
{
  FILE *g;
  citire();
  bordare();
  depune(i_prim,j_prim);
  g=fopen("albina.out","w");
  fprintf(g,"%d",aria());
  fclose(g);
  return 0;
}

