#include <stdio.h>

#define Infinit 99999

typedef struct     //structura unei camere
	 {
	   long nr,    //numarul de persoane
	   pers[2];    //cele (maxim) 2 persoane (greutatile)
	 } camera;

long    pers[10];
camera  cam[5], best_cam[5];
int     nr_cam, nr_pers;
long    best_Cdez=Infinit, medie;


long abs(long x)
{
  if (x<0) return -x;
  return x;
}

long calc_Cdez(void) //calculeaza coef de dezechilibru

{
  long Cdez=0;
  int i,j;

  for (i=0; i<nr_cam; i++)
    Cdez+=abs((nr_cam*(cam[i].pers[0]+cam[i].pers[1]))-medie);
  return(Cdez);
}

void citire(void)
{
  int i;
  FILE *inp;
  inp=fopen("statie.in","r");
  fscanf(inp, "%d %d", &nr_cam, &nr_pers);
  medie = 0;
  for (i=0; i<5; i++)        //initializeaza cu 0 toate camerele
    {
      cam[i].nr=0;           //numarul de persoane
      cam[i].pers[0]=0;      //persoana 1
      cam[i].pers[1]=0;      //persoana 2
    }
  for (i=0; i<nr_pers; i++)  //greutatile celor nr_pers persoane
    {
      fscanf(inp, "%d ", &(pers[i]));
      medie+=pers[i];        //se calculeaza si suma greutatilor
    }
 fclose(inp);
}

void calcul(int k)        //back - se incearca repartizarea
{                         //       persoanei k
  long temp;
  int i,j;
  if (k==nr_pers)         //daca le-am repartizat pe toate
    {
      temp=calc_Cdez();   //calculam coeficientul de dezechilibru
      if (temp<best_Cdez) //daca e mai bun
	    {
	      best_Cdez=temp; //il retinem
	      for (i=0; i<nr_cam; i++) best_cam[i]=cam[i];
	    }
    }
  else                    //nu i-am repartizat pe toti
    for (j=0; j<nr_cam; j++)//parcurg toate camerele si
      if (cam[j].nr<2)    //daca in camera j mai e loc
	    {
	      cam[j].pers[cam[j].nr]=pers[k]; //pun persoana aici
	      cam[j].nr++;    //contorizez ca am pus inca o persoana
	      calcul(k+1);    //trec la persoana urmatoare
	      cam[j].nr--;    //la revenire scad numarul de persoane
	      cam[j].pers[cam[j].nr]=0;//greutatea la loc pe 0
	    }
}

void afisare(void)
{
  FILE  *outp;
  outp=fopen("statie.out","w");
  fprintf(outp, "%5.3f\n", ((float)(best_Cdez))/((float)nr_cam));
  fclose(outp);
}

void main(void)
{
  citire();
  calcul(0);
  afisare();
}