Program Statie;
Const Infinit=99999;

Type Camera = Record         {structura unei camere}
	        nr: LongInt; {numarul de persoane}
	        pers: Array[0..1] Of Word;{cele (maxim) 2 persoane (greutatile)}
	      End;
Var pers: Array[0..10] Of Word;
    cam: Array[0..5] Of Camera;
    best_cam: Array[0..5] Of Camera;
    nr_cam, nr_pers: Integer;
    best_Cdez, medie: LongInt;
    inp, outp: Text;


Function abs(x: LongInt): LongInt;
Begin
  If (x<0) Then
     abs := -x
  Else
     abs := x;
End;

Function calc_Cdez: LongInt; {calculeaza coef de dezechilibru}
Var Cdez: LongInt;
    i: Integer;
Begin
  Cdez := 0;
  For i := 0 To nr_cam-1 Do
      Cdez := Cdez + abs((nr_cam * (cam[i].pers[0] + cam[i].pers[1])) - medie);
  calc_Cdez := Cdez
End;

Procedure Citire;
Var i: Integer;
Begin
  Assign(inp, 'statie.in'); Reset(inp);
  ReadLn(inp, nr_cam, nr_pers);          {camere, persoane}
  medie := 0;
  For i := 0 To 5 Do            {initializeaza cu 0 toate camerele}
    Begin
      cam[i].nr := 0;               {numarul de persoane}
      cam[i].pers[0] := 0;          {persoana 1}
      cam[i].pers[1] := 0;          {persoana 2}
    End;
  For i := 0 To nr_pers-1 Do    {greutatile celor nr_pers persoane}
    Begin
      Read(inp, pers[i]);
      medie := medie + pers[i];     {se calculeaza si suma greutatilor}
    End;
  close(inp)
End;

Procedure calcul(k: Integer);  {back - se incearca repartizarea}
Var temp: LongInt;             {       persoanei k}
    i, j: Integer;
Begin
  If k=nr_pers Then            {daca le-am repartizat pe toate}
     Begin
       temp := calc_Cdez;      {calculam coeficientul de dezechilibru}
       If temp<best_Cdez Then  {daca e mai bun}
	 Begin
	   best_Cdez := temp;  {il retinem}
	   For i := 0 To nr_cam-1 Do
	     best_cam[i] := cam[i]{si retinem configuratia camerelor}
	 End
     End
  Else                         {nu i-am repartizat pe toti}
    for j := 0 To nr_cam-1 Do  {parcurg toate camerele si}
      if cam[j].nr<2 Then      {daca in camera j mai e loc}
	Begin
	  cam[j].pers[cam[j].nr] := pers[k]; {pun persoana aici}
	  Inc(cam[j].nr);            {contorizez ca am pus inca o persoana}
	  calcul(k+1);               {trec la persoana urmatoare}
	  Dec(cam[j].nr);            {la revenire scad numarul de persoane}
	  cam[j].pers[cam[j].nr] := 0;{pun greutatea respectiva la loc pe 0}
	End
End;

Procedure afisare;
Var i, j: Integer;
Begin
  Assign(outp, 'statie.out'); ReWrite(outp);
{  for i := 0 To nr_cam-1 Do        (*pentru fiecare camera*)
    Begin
      Write(outp, i, ': ');         (*afisez camera si*)
      for j := 0 To best_cam[i].nr-1 Do (*componenta ei*)
	  Write(outp, best_cam[i].pers[j], ' ');
      WriteLn(outp)
    End; }                          (*apoi afisez coeficientul*)
  WriteLn(outp, best_Cdez/nr_cam:0:3);
  close(outp)
End;

Begin
  best_Cdez := Infinit;
  citire;
  calcul(0);
  afisare;
End.