Program Tricou;
Type CeVreaConcurent = Record
                   mi, mf: Integer;
                 End;
     Concurent = Integer;

Var Fin, Fout: Text;
    n, Cati, CatiMax, SDisp, PanaAiciCaut: Integer;
    Marime: Array[1..30] Of CeVreaConcurent;
    Disponibile: Array[1..5] Of Integer;
    Sol: Array[1..30] Of Boolean;
    SolNr: Array[1..30] Of Integer;

Function min(x, y: Integer): Integer;
Begin
  min := x;
  If y<x Then min := y
End;

Procedure Citire;
Var i, j, DeLa, PanaLa: Integer;
    x1, x2: Char;
Begin
  ReadLn(Fin, n);
  For i := 1 To n Do          {pentru cei n concurenti}
    Begin
      Read(Fin, x1, x2);      {citesc marime mica si marime mare}
      Case x1 Of              {transform in indice x1}
        'S': DeLa := 1;
        'M': DeLa := 2;
        'L': DeLa := 3;
        'X': DeLa := 4;
        'T': DeLa := 5;
      End;
      Case x2 Of              {transform in indice x2}
        'S': PanaLa := 1;
        'M': PanaLa := 2;
        'L': PanaLa := 3;
        'X': PanaLa := 4;
        'T': PanaLa := 5;
      End;
      Marime[i].mi := DeLa;   {retin pentru concurentul i}
      Marime[i].mf := PanaLa; {marimile solicitate       }
      Read(Fin, x1);    {citesc spatiul dintre concurenti/enterul de la sfarsit}
    End;
  For i := 1 To 5 Do          {numarul de tricouri disponibile}
    Begin
      Read(Fin, Disponibile[i]);
      Sdisp := Sdisp + Disponibile[i]
    End;
  PanaAiciCaut := min(n, SDisp);
  Close(Fin)
End;

Procedure Da_Tricou(k: Concurent); {incerc sa dau tricou concurentului k}
Var i, j: Integer;                 {deci am dat tricou primilor k-1     }
Begin
  If (k<=n) AND (CatiMax<PanaAiciCaut) Then {daca mai am concurenti si tricouri}
    For i := Marime[k].mi To Marime[k].mf Do{incearca toate marimile pe care le-a solicitat k}
      Begin
        If Disponibile[i]>0 Then            {daca mai sunt}
          Begin
            Sol[k] := TRUE; Inc(Cati);           {da tricou si numara ca mai ai un concurent cu tricou}
            SolNr[k] := i;
            Dec(Disponibile[i]);                 {l-ai dat, scade din disponibile}
            If Cati>CatiMax Then CatiMax := Cati;{vezi daca sunt mai multi cu tricou decat pana acum}
            Da_Tricou(k+1);                      {treci la alt concurent}
            Inc(Disponibile[i]);                      {la revenire refa disponibile}
            Dec(Cati);                                {ii iau tricoul}
            SolNr[k] := 0;
            Sol[k] := FALSE                           {il scot din solutie}
          End
        Else                                {daca nu mai sunt}
          Da_Tricou(k+1)                         {treci la alt concurent}
      End;
End;

Begin
  Assign(Fin, 'tricouri.in'); Reset(Fin);
  Assign(Fout, 'tricouri.out'); ReWrite(Fout);
  Citire;        {citeste datele si retine informatiile utile}

  Da_Tricou(1);  {incep sa dau tricouri incepand cu primul concurent}

  WriteLn(Fout, CatiMax);  {atatia au primit tricouri}
  Close(Fout);
End.
